Index: trunk/src/lib/collision_detection/obb_tree_node.cc
===================================================================
--- trunk/src/lib/collision_detection/obb_tree_node.cc	(revision 7677)
+++ trunk/src/lib/collision_detection/obb_tree_node.cc	(revision 7711)
@@ -616,80 +416,67 @@
   the points depending on which side they are located
   */
-  tList<const sVec3D>      partition1;                           //!< the vertex partition 1
-  tList<const sVec3D>      partition2;                           //!< the vertex partition 2
-
-
-  PRINTF(3)("vertex index: %i, of %i\n", vertexIndex, box->numOfVertices);
-  this->separationPlane = new Plane(box->axis[axisIndex], box->vertices[vertexIndex]);  //!< separation plane
-  this->sepPlaneCenter = &box->vertices[vertexIndex];
-  this->longestAxisIndex = axisIndex;
-
-  for(int i = 0; i < box->numOfVertices; ++i)
-  {
-    if( i == vertexIndex) continue;
-    tmpDist = this->separationPlane->distancePoint(box->vertices[i]);
-    if( tmpDist > 0.0)
-      partition1.add(&box->vertices[i]); /* positive numbers plus zero */
-    else
-      partition2.add(&box->vertices[i]); /* negatice numbers */
-  }
-  partition1.add(&box->vertices[vertexIndex]);
-  partition2.add(&box->vertices[vertexIndex]);
-
-  PRINTF(3)("\npartition1: got %i vertices/ partition 2: got %i vertices\n", partition1.getSize(), partition2.getSize());
+  std::list<int>           partition1;                           //!< the vertex partition 1
+  std::list<int>           partition2;                           //!< the vertex partition 2
+  float*                   triangleCenter = new float[3];        //!< the center of the triangle
+  const float*             a;                                    //!< triangle  edge a
+  const float*             b;                                    //!< triangle  edge b
+  const float*             c;                                    //!< triangle  edge c
+
+
+  /* find the center of the box */
+  this->separationPlane = Plane(box.axis[longestAxisIndex], box.center);
+  this->sepPlaneCenter[0] = box.center.x;
+  this->sepPlaneCenter[1] = box.center.y;
+  this->sepPlaneCenter[2] = box.center.z;
+  this->longestAxisIndex = longestAxisIndex;
+
+  for( int i = 0; i < box.triangleIndexesLength; ++i)
+  {
+    /* first calculate the middle of the triangle */
+    a = &box.modelInf->pVertices[box.modelInf->pTriangles[box.triangleIndexes[i]].indexToVertices[0]];
+    b = &box.modelInf->pVertices[box.modelInf->pTriangles[box.triangleIndexes[i]].indexToVertices[1]];
+    c = &box.modelInf->pVertices[box.modelInf->pTriangles[box.triangleIndexes[i]].indexToVertices[2]];
+
+    triangleCenter[0] = (a[0] + b[0] + c[0]) / 3.0f;
+    triangleCenter[1] = (a[1] + b[1] + c[1]) / 3.0f;
+    triangleCenter[2] = (a[2] + b[2] + c[2]) / 3.0f;
+    tmpDist = this->separationPlane.distancePoint(*((sVec3D*)triangleCenter));
+
+    if( tmpDist > 0.0f)
+      partition1.push_back(box.triangleIndexes[i]); /* positive numbers plus zero */
+    else if( tmpDist < 0.0f)
+      partition2.push_back(box.triangleIndexes[i]); /* negatice numbers */
+    else {
+      partition1.push_back(box.triangleIndexes[i]); /* 0.0f? unprobable... */
+      partition2.push_back(box.triangleIndexes[i]);
+    }
+  }
+  PRINTF(3)("\nPartition1: got \t%i Vertices \nPartition2: got \t%i Vertices\n", partition1.size(), partition2.size());
 
 
   /* now comes the separation into two different sVec3D arrays */
-  tIterator<const sVec3D>* iterator;                       //!< the iterator to go through the lists
-  const sVec3D*      element;                              //!< the elements
   int                index;                                //!< index storage place
-  sVec3D*            vertList1;                            //!< the vertex list 1
-  sVec3D*            vertList2;                            //!< the vertex list 2
-
-  vertList1 = new sVec3D[partition1.getSize()];
-  vertList2 = new sVec3D[partition2.getSize()];
-
-  iterator = partition1.getIterator();
-  element = iterator->firstElement();
-  index = 0;
-  while( element != NULL)
-  {
-    vertList1[index][0] = element[0][0];
-    vertList1[index][1] = element[0][1];
-    vertList1[index][2] = element[0][2];
-    ++index;
-    element = iterator->nextElement();
-  }
-
-//   PRINTF(0)("\npartition 1:\n");
-//   for(int i = 0; i < partition1.getSize(); ++i)
-//   {
-//     PRINTF(0)("v[%i][0] = %f,\tv[%i][1] = %f,\tv[%i][1] = %f\n", i, vertList1[i][0], i, vertList1[i][1], i, vertList1[i][2]);
-//   }
-
-  iterator = partition2.getIterator();
-  element = iterator->firstElement();
-  index = 0;
-  while( element != NULL)
-  {
-    vertList2[index][0] = element[0][0];
-    vertList2[index][1] = element[0][1];
-    vertList2[index][2] = element[0][2];
-    ++index;
-    element = iterator->nextElement();
-  }
-
-  this->tmpVert1 = vertList1;
-  this->tmpVert2 = vertList2;
-  this->tmpLen1 = partition1.getSize();
-  this->tmpLen2 = partition2.getSize();
-
-  delete iterator;
-
-//   PRINTF(0)("\npartition 2:\n");
-//   for(int i = 0; i < partition2.getSize(); ++i)
-//   {
-//     PRINTF(0)("v[%i][0] = %f,\tv[%i][1] = %f,\tv[%i][1] = %f\n", i, vertList2[i][0], i,  vertList2[i][1], i, vertList2[i][2]);
-//   }
+  int*               triangleIndexList1;                   //!< the vertex list 1
+  int*               triangleIndexList2;                   //!< the vertex list 2
+  std::list<int>::iterator element;                        //!< the list iterator
+
+  triangleIndexList1 = new int[partition1.size()];
+  triangleIndexList2 = new int[partition2.size()];
+
+  for( element = partition1.begin(), index = 0; element != partition1.end(); element++, index++)
+    triangleIndexList1[index] = (*element);
+
+  for( element = partition2.begin(), index = 0; element != partition2.end(); element++, index++)
+    triangleIndexList2[index] = (*element);
+
+  if( this->triangleIndexList1!= NULL)
+    delete[] this->triangleIndexList1;
+  this->triangleIndexList1 = triangleIndexList1;
+  this->triangleIndexLength1 = partition1.size();
+
+  if( this->triangleIndexList2 != NULL)
+    delete[] this->triangleIndexList2;
+  this->triangleIndexList2 = triangleIndexList2;
+  this->triangleIndexLength2 = partition2.size();
 }
 
@@ -699,21 +486,25 @@
 void OBBTreeNode::collideWith(BVTreeNode* treeNode, WorldEntity* nodeA, WorldEntity* nodeB)
 {
-  PRINTF(3)("collideWith\n");
+  if( unlikely(treeNode == NULL))
+    return;
+
+  PRINTF(4)("collideWith\n");
   /* if the obb overlap, make subtests: check which node is realy overlaping  */
-  PRINT(3)("Checking OBB %i vs %i: ", this->getIndex(), treeNode->getIndex());
-  if( unlikely(treeNode == NULL)) return;
-
-  if( this->overlapTest(this->bvElement, ((OBBTreeNode*)treeNode)->bvElement, nodeA, nodeB))
-  {
-    PRINTF(3)("collision @ lvl %i, object %s vs. %s, (%p, %p)\n", this->depth, nodeA->getClassName(), nodeB->getClassName(), this->nodeLeft, this->nodeRight);
+  PRINTF(4)("Checking OBB %i vs %i: ", this->getIndex(), treeNode->getIndex());
+  //   if( unlikely(treeNode == NULL)) return;
+
+
+  if( this->overlapTest(*this->bvElement, *(((const OBBTreeNode*)&treeNode)->bvElement), nodeA, nodeB))
+  {
+    PRINTF(4)("collision @ lvl %i, object %s vs. %s, (%p, %p)\n", this->depth, nodeA->getClassName(), nodeB->getClassName(), this->nodeLeft, this->nodeRight);
 
     /* check if left node overlaps */
     if( likely( this->nodeLeft != NULL))
     {
-      PRINT(3)("Checking OBB %i vs %i: ", this->nodeLeft->getIndex(), treeNode->getIndex());
-      if( this->overlapTest(this->nodeLeft->bvElement, ((OBBTreeNode*)treeNode)->bvElement, nodeA, nodeB))
+      PRINTF(4)("Checking OBB %i vs %i: ", this->nodeLeft->getIndex(), treeNode->getIndex());
+      if( this->overlapTest(*this->nodeLeft->bvElement, *(((const OBBTreeNode*)&treeNode)->bvElement), nodeA, nodeB))
       {
-        this->nodeLeft->collideWith(((OBBTreeNode*)treeNode)->nodeLeft, nodeA, nodeB);
-        this->nodeLeft->collideWith(((OBBTreeNode*)treeNode)->nodeRight, nodeA, nodeB);
+        this->nodeLeft->collideWith((((const OBBTreeNode*)treeNode)->nodeLeft), nodeA, nodeB);
+        this->nodeLeft->collideWith((((const OBBTreeNode*)treeNode)->nodeRight), nodeA, nodeB);
       }
     }
@@ -721,27 +512,33 @@
     if( likely( this->nodeRight != NULL))
     {
-      PRINT(3)("Checking OBB %i vs %i: ", this->nodeRight->getIndex(), treeNode->getIndex());
-      if(this->overlapTest(this->nodeRight->bvElement, ((OBBTreeNode*)treeNode)->bvElement, nodeA, nodeB))
+      PRINTF(4)("Checking OBB %i vs %i: ", this->nodeRight->getIndex(), treeNode->getIndex());
+      if(this->overlapTest(*this->nodeRight->bvElement, *(((const OBBTreeNode*)&treeNode)->bvElement), nodeA, nodeB))
       {
-       this->nodeRight->collideWith(((OBBTreeNode*)treeNode)->nodeLeft, nodeA, nodeB);
-       this->nodeRight->collideWith(((OBBTreeNode*)treeNode)->nodeRight, nodeA, nodeB);
+        this->nodeRight->collideWith((((const OBBTreeNode*)treeNode)->nodeLeft), nodeA, nodeB);
+        this->nodeRight->collideWith((((const OBBTreeNode*)treeNode)->nodeRight), nodeA, nodeB);
       }
     }
 
     /* so there is a collision and this is the last box in the tree (i.e. leaf) */
+    /* FIXME: If we would choose || insead of && there would also be asymmetrical cases supported */
     if( unlikely(this->nodeRight == NULL && this->nodeLeft == NULL))
     {
-      nodeA->collidesWith(nodeB, *((OBBTreeNode*)treeNode)->bvElement->center);
-
-      nodeB->collidesWith(nodeA, *this->bvElement->center);
-    }
-
-  }
-}
-
-
-
-bool OBBTreeNode::overlapTest(OBB* boxA, OBB* boxB, WorldEntity* nodeA, WorldEntity* nodeB)
-{
+      nodeA->collidesWith(nodeB, (((const OBBTreeNode*)&treeNode)->bvElement->center));
+
+      nodeB->collidesWith(nodeA, this->bvElement->center);
+    }
+
+  }
+}
+
+
+
+bool OBBTreeNode::overlapTest(OBB& boxA, OBB& boxB, WorldEntity* nodeA, WorldEntity* nodeB)
+{
+  //HACK remove this again
+  this->owner = nodeA;
+  //   if( boxB == NULL || boxA == NULL)
+  //     return false;
+
   /* first check all axis */
   Vector t;
@@ -752,22 +549,23 @@
   Vector rotAxisB[3];
 
-  rotAxisA[0] =  nodeA->getAbsDir().apply(boxA->axis[0]);
-  rotAxisA[1] =  nodeA->getAbsDir().apply(boxA->axis[1]);
-  rotAxisA[2] =  nodeA->getAbsDir().apply(boxA->axis[2]);
-
-  rotAxisB[0] =  nodeB->getAbsDir().apply(boxB->axis[0]);
-  rotAxisB[1] =  nodeB->getAbsDir().apply(boxB->axis[1]);
-  rotAxisB[2] =  nodeB->getAbsDir().apply(boxB->axis[2]);
-
-  t = nodeA->getAbsCoor() + nodeA->getAbsDir().apply(*boxA->center) - ( nodeB->getAbsCoor() + nodeB->getAbsDir().apply(*boxB->center));
-
-//   printf("\n");
-//   printf("(%f, %f, %f) -> (%f, %f, %f)\n", boxA->axis[0].x, boxA->axis[0].y, boxA->axis[0].z, rotAxisA[0].x, rotAxisA[0].y, rotAxisA[0].z);
-//   printf("(%f, %f, %f) -> (%f, %f, %f)\n", boxA->axis[1].x, boxA->axis[1].y, boxA->axis[1].z, rotAxisA[1].x, rotAxisA[1].y, rotAxisA[1].z);
-//   printf("(%f, %f, %f) -> (%f, %f, %f)\n", boxA->axis[2].x, boxA->axis[2].y, boxA->axis[2].z, rotAxisA[2].x, rotAxisA[2].y, rotAxisA[2].z);
-//
-//   printf("(%f, %f, %f) -> (%f, %f, %f)\n", boxB->axis[0].x, boxB->axis[0].y, boxB->axis[0].z, rotAxisB[0].x, rotAxisB[0].y, rotAxisB[0].z);
-//   printf("(%f, %f, %f) -> (%f, %f, %f)\n", boxB->axis[1].x, boxB->axis[1].y, boxB->axis[1].z, rotAxisB[1].x, rotAxisB[1].y, rotAxisB[1].z);
-//   printf("(%f, %f, %f) -> (%f, %f, %f)\n", boxB->axis[2].x, boxB->axis[2].y, boxB->axis[2].z, rotAxisB[2].x, rotAxisB[2].y, rotAxisB[2].z);
+  rotAxisA[0] =  nodeA->getAbsDir().apply(boxA.axis[0]);
+  rotAxisA[1] =  nodeA->getAbsDir().apply(boxA.axis[1]);
+  rotAxisA[2] =  nodeA->getAbsDir().apply(boxA.axis[2]);
+
+  rotAxisB[0] =  nodeB->getAbsDir().apply(boxB.axis[0]);
+  rotAxisB[1] =  nodeB->getAbsDir().apply(boxB.axis[1]);
+  rotAxisB[2] =  nodeB->getAbsDir().apply(boxB.axis[2]);
+
+
+  t = nodeA->getAbsCoor() + nodeA->getAbsDir().apply(boxA.center) - ( nodeB->getAbsCoor() + nodeB->getAbsDir().apply(boxB.center));
+
+  //   printf("\n");
+  //   printf("(%f, %f, %f) -> (%f, %f, %f)\n", boxA->axis[0].x, boxA->axis[0].y, boxA->axis[0].z, rotAxisA[0].x, rotAxisA[0].y, rotAxisA[0].z);
+  //   printf("(%f, %f, %f) -> (%f, %f, %f)\n", boxA->axis[1].x, boxA->axis[1].y, boxA->axis[1].z, rotAxisA[1].x, rotAxisA[1].y, rotAxisA[1].z);
+  //   printf("(%f, %f, %f) -> (%f, %f, %f)\n", boxA->axis[2].x, boxA->axis[2].y, boxA->axis[2].z, rotAxisA[2].x, rotAxisA[2].y, rotAxisA[2].z);
+  //
+  //   printf("(%f, %f, %f) -> (%f, %f, %f)\n", boxB->axis[0].x, boxB->axis[0].y, boxB->axis[0].z, rotAxisB[0].x, rotAxisB[0].y, rotAxisB[0].z);
+  //   printf("(%f, %f, %f) -> (%f, %f, %f)\n", boxB->axis[1].x, boxB->axis[1].y, boxB->axis[1].z, rotAxisB[1].x, rotAxisB[1].y, rotAxisB[1].z);
+  //   printf("(%f, %f, %f) -> (%f, %f, %f)\n", boxB->axis[2].x, boxB->axis[2].y, boxB->axis[2].z, rotAxisB[2].x, rotAxisB[2].y, rotAxisB[2].z);
 
 
@@ -779,17 +577,17 @@
     l = rotAxisA[j];
 
-    rA += fabs(boxA->halfLength[0] * rotAxisA[0].dot(l));
-    rA += fabs(boxA->halfLength[1] * rotAxisA[1].dot(l));
-    rA += fabs(boxA->halfLength[2] * rotAxisA[2].dot(l));
-
-    rB += fabs(boxB->halfLength[0] * rotAxisB[0].dot(l));
-    rB += fabs(boxB->halfLength[1] * rotAxisB[1].dot(l));
-    rB += fabs(boxB->halfLength[2] * rotAxisB[2].dot(l));
-
-    PRINTF(3)("s = %f, rA+rB = %f\n", fabs(t.dot(l)), rA+rB);
+    rA += fabs(boxA.halfLength[0] * rotAxisA[0].dot(l));
+    rA += fabs(boxA.halfLength[1] * rotAxisA[1].dot(l));
+    rA += fabs(boxA.halfLength[2] * rotAxisA[2].dot(l));
+
+    rB += fabs(boxB.halfLength[0] * rotAxisB[0].dot(l));
+    rB += fabs(boxB.halfLength[1] * rotAxisB[1].dot(l));
+    rB += fabs(boxB.halfLength[2] * rotAxisB[2].dot(l));
+
+    PRINTF(5)("s = %f, rA+rB = %f\n", fabs(t.dot(l)), rA+rB);
 
     if( (rA + rB) < fabs(t.dot(l)))
     {
-      PRINT(3)("no Collision\n");
+      PRINTF(4)("no Collision\n");
       return false;
     }
@@ -803,17 +601,17 @@
     l = rotAxisB[j];
 
-    rA += fabs(boxA->halfLength[0] * rotAxisA[0].dot(l));
-    rA += fabs(boxA->halfLength[1] * rotAxisA[1].dot(l));
-    rA += fabs(boxA->halfLength[2] * rotAxisA[2].dot(l));
-
-    rB += fabs(boxB->halfLength[0] * rotAxisB[0].dot(l));
-    rB += fabs(boxB->halfLength[1] * rotAxisB[1].dot(l));
-    rB += fabs(boxB->halfLength[2] * rotAxisB[2].dot(l));
-
-    PRINTF(3)("s = %f, rA+rB = %f\n", fabs(t.dot(l)), rA+rB);
+    rA += fabs(boxA.halfLength[0] * rotAxisA[0].dot(l));
+    rA += fabs(boxA.halfLength[1] * rotAxisA[1].dot(l));
+    rA += fabs(boxA.halfLength[2] * rotAxisA[2].dot(l));
+
+    rB += fabs(boxB.halfLength[0] * rotAxisB[0].dot(l));
+    rB += fabs(boxB.halfLength[1] * rotAxisB[1].dot(l));
+    rB += fabs(boxB.halfLength[2] * rotAxisB[2].dot(l));
+
+    PRINTF(5)("s = %f, rA+rB = %f\n", fabs(t.dot(l)), rA+rB);
 
     if( (rA + rB) < fabs(t.dot(l)))
     {
-      PRINT(3)("no Collision\n");
+      PRINTF(4)("no Collision\n");
       return false;
     }
@@ -831,17 +629,17 @@
       l = rotAxisA[j].cross(rotAxisB[k]);
 
-      rA += fabs(boxA->halfLength[0] * rotAxisA[0].dot(l));
-      rA += fabs(boxA->halfLength[1] * rotAxisA[1].dot(l));
-      rA += fabs(boxA->halfLength[2] * rotAxisA[2].dot(l));
-
-      rB += fabs(boxB->halfLength[0] * rotAxisB[0].dot(l));
-      rB += fabs(boxB->halfLength[1] * rotAxisB[1].dot(l));
-      rB += fabs(boxB->halfLength[2] * rotAxisB[2].dot(l));
-
-      PRINTF(3)("s = %f, rA+rB = %f\n", fabs(t.dot(l)), rA+rB);
+      rA += fabs(boxA.halfLength[0] * rotAxisA[0].dot(l));
+      rA += fabs(boxA.halfLength[1] * rotAxisA[1].dot(l));
+      rA += fabs(boxA.halfLength[2] * rotAxisA[2].dot(l));
+
+      rB += fabs(boxB.halfLength[0] * rotAxisB[0].dot(l));
+      rB += fabs(boxB.halfLength[1] * rotAxisB[1].dot(l));
+      rB += fabs(boxB.halfLength[2] * rotAxisB[2].dot(l));
+
+      PRINTF(5)("s = %f, rA+rB = %f\n", fabs(t.dot(l)), rA+rB);
 
       if( (rA + rB) < fabs(t.dot(l)))
       {
-        PRINT(3)("keine Kollision\n");
+        PRINTF(4)("keine Kollision\n");
         return false;
       }
@@ -849,8 +647,10 @@
   }
 
-
-  boxA->bCollided = true; /* use this ONLY(!!!!) for drawing operations */
-  boxB->bCollided = true;
-  PRINT(3)("Kollision!\n");
+  /* FIXME: there is no collision mark set now */
+     boxA.bCollided = true; /* use this ONLY(!!!!) for drawing operations */
+     boxB.bCollided = true;
+
+
+  PRINTF(4)("Kollision!\n");
   return true;
 }
@@ -860,28 +660,30 @@
 
 
+
+
+
+
+
+/**
+ *
+ * draw the BV tree - debug mode
+ */
 void OBBTreeNode::drawBV(int depth, int drawMode, const Vector& color,  bool top) const
 {
-
-  /* draw the model itself, there is some problem concerning this: the vertices are drawn multiple times */
-  if( drawMode & DRAW_MODEL || drawMode & DRAW_ALL)
-  {
-    if( !(drawMode & DRAW_SINGLE && depth != 0))
-    {
-      if( drawMode & DRAW_POINTS)
+  /* this function can be used to draw the triangles and/or the points only  */
+  if( 1 /*drawMode & DRAW_MODEL || drawMode & DRAW_ALL*/)
+  {
+    if( depth == 0/*!(drawMode & DRAW_SINGLE && depth != 0)*/)
+    {
+      if( 1 /*drawMode & DRAW_POINTS*/)
+      {
         glBegin(GL_POINTS);
-      for(int i = 0; i < this->bvElement->numOfVertices; ++i)
-      {
-        if( drawMode & DRAW_POINTS)
-          glVertex3f(this->bvElement->vertices[i][0], this->bvElement->vertices[i][1], this->bvElement->vertices[i][2]);
-        else
-        {
-          glPushMatrix();
-          glTranslatef(this->bvElement->vertices[i][0], this->bvElement->vertices[i][1], this->bvElement->vertices[i][2]);
-          gluSphere(OBBTreeNode_sphereObj, 0.1, 10, 10);
-          glPopMatrix();
-        }
+        glColor3f(0.3, 0.8, 0.54);
+        for( int i = 0; i < this->bvElement->modelInf->numVertices*3; i+=3)
+          glVertex3f(this->bvElement->modelInf->pVertices[i],
+                     this->bvElement->modelInf->pVertices[i+1],
+                     this->bvElement->modelInf->pVertices[i+2]);
+        glEnd();
       }
-      if( drawMode & DRAW_POINTS)
-        glEnd();
     }
   }
@@ -897,5 +699,5 @@
 
   /* draw world axes */
-  if( drawMode & DRAW_BV_AXIS)
+  if( 1 /*drawMode & DRAW_BV_AXIS*/)
   {
     glBegin(GL_LINES);
@@ -915,25 +717,27 @@
 
 
-  if( drawMode & DRAW_BV_AXIS || drawMode & DRAW_ALL)
-  {
-    if( !(drawMode & DRAW_SINGLE && depth != 0))
+  if( 1/*drawMode & DRAW_BV_AXIS || drawMode & DRAW_ALL*/)
+  {
+    if( 1/*drawMode & DRAW_SINGLE && depth != 0*/)
     {
       /* draw the obb axes */
       glBegin(GL_LINES);
-      glColor3f(0.0, 0.4, 0.3);
-      glVertex3f(this->bvElement->center->x, this->bvElement->center->y, this->bvElement->center->z);
-      glVertex3f(this->bvElement->center->x + this->bvElement->axis[0].x * this->bvElement->halfLength[0],
-                 this->bvElement->center->y + this->bvElement->axis[0].y * this->bvElement->halfLength[0],
-                 this->bvElement->center->z + this->bvElement->axis[0].z * this->bvElement->halfLength[0]);
-
-      glVertex3f(this->bvElement->center->x, this->bvElement->center->y, this->bvElement->center->z);
-      glVertex3f(this->bvElement->center->x + this->bvElement->axis[1].x * this->bvElement->halfLength[1],
-                 this->bvElement->center->y + this->bvElement->axis[1].y * this->bvElement->halfLength[1],
-                 this->bvElement->center->z + this->bvElement->axis[1].z * this->bvElement->halfLength[1]);
-
-      glVertex3f(this->bvElement->center->x, this->bvElement->center->y, this->bvElement->center->z);
-      glVertex3f(this->bvElement->center->x + this->bvElement->axis[2].x * this->bvElement->halfLength[2],
-                 this->bvElement->center->y + this->bvElement->axis[2].y * this->bvElement->halfLength[2],
-                 this->bvElement->center->z + this->bvElement->axis[2].z * this->bvElement->halfLength[2]);
+      glColor3f(1.0, 0.0, 0.0);
+      glVertex3f(this->bvElement->center.x, this->bvElement->center.y, this->bvElement->center.z);
+      glVertex3f(this->bvElement->center.x + this->bvElement->axis[0].x * this->bvElement->halfLength[0],
+                 this->bvElement->center.y + this->bvElement->axis[0].y * this->bvElement->halfLength[0],
+                 this->bvElement->center.z + this->bvElement->axis[0].z * this->bvElement->halfLength[0]);
+
+      glColor3f(0.0, 1.0, 0.0);
+      glVertex3f(this->bvElement->center.x, this->bvElement->center.y, this->bvElement->center.z);
+      glVertex3f(this->bvElement->center.x + this->bvElement->axis[1].x * this->bvElement->halfLength[1],
+                 this->bvElement->center.y + this->bvElement->axis[1].y * this->bvElement->halfLength[1],
+                 this->bvElement->center.z + this->bvElement->axis[1].z * this->bvElement->halfLength[1]);
+
+      glColor3f(0.0, 0.0, 1.0);
+      glVertex3f(this->bvElement->center.x, this->bvElement->center.y, this->bvElement->center.z);
+      glVertex3f(this->bvElement->center.x + this->bvElement->axis[2].x * this->bvElement->halfLength[2],
+                 this->bvElement->center.y + this->bvElement->axis[2].y * this->bvElement->halfLength[2],
+                 this->bvElement->center.z + this->bvElement->axis[2].z * this->bvElement->halfLength[2]);
       glEnd();
     }
@@ -950,101 +754,41 @@
     }
 
-    if(this->nodeLeft == NULL || this->nodeRight == NULL)
+    if( this->nodeLeft == NULL && this->nodeRight == NULL)
       depth = 0;
-    if( !(drawMode & DRAW_SINGLE && depth != 0))
-    {
-    Vector cen = *this->bvElement->center;
-    Vector* axis = this->bvElement->axis;
-    float* len = this->bvElement->halfLength;
-
-    if( this->bvElement->bCollided)
-    {
-      glColor4f(1.0, 1.0, 1.0, .5); // COLLISION COLOR
-    }
-    else if( drawMode & DRAW_BV_BLENDED)
-    {
-      glColor4f(color.x, color.y, color.z, .5);
-    }
-
-    /* draw bounding box */
-    if( drawMode & DRAW_BV_BLENDED)
-      glBegin(GL_QUADS);
-    else
-      glBegin(GL_LINE_LOOP);
-    glVertex3f(cen.x + axis[0].x * len[0] + axis[1].x * len[1] + axis[2].x * len[2],
-               cen.y + axis[0].y * len[0] + axis[1].y * len[1] + axis[2].y * len[2],
-               cen.z + axis[0].z * len[0] + axis[1].z * len[1] + axis[2].z * len[2]);
-    glVertex3f(cen.x + axis[0].x * len[0] + axis[1].x * len[1] - axis[2].x * len[2],
-               cen.y + axis[0].y * len[0] + axis[1].y * len[1] - axis[2].y * len[2],
-               cen.z + axis[0].z * len[0] + axis[1].z * len[1] - axis[2].z * len[2]);
-    glVertex3f(cen.x + axis[0].x * len[0] - axis[1].x * len[1] - axis[2].x * len[2],
-               cen.y + axis[0].y * len[0] - axis[1].y * len[1] - axis[2].y * len[2],
-               cen.z + axis[0].z * len[0] - axis[1].z * len[1] - axis[2].z * len[2]);
-    glVertex3f(cen.x + axis[0].x * len[0] - axis[1].x * len[1] + axis[2].x * len[2],
-               cen.y + axis[0].y * len[0] - axis[1].y * len[1] + axis[2].y * len[2],
-               cen.z + axis[0].z * len[0] - axis[1].z * len[1] + axis[2].z * len[2]);
-    glEnd();
-
-    if( drawMode & DRAW_BV_BLENDED)
-      glBegin(GL_QUADS);
-    else
-      glBegin(GL_LINE_LOOP);
-    glVertex3f(cen.x + axis[0].x * len[0] - axis[1].x * len[1] + axis[2].x * len[2],
-               cen.y + axis[0].y * len[0] - axis[1].y * len[1] + axis[2].y * len[2],
-               cen.z + axis[0].z * len[0] - axis[1].z * len[1] + axis[2].z * len[2]);
-    glVertex3f(cen.x + axis[0].x * len[0] - axis[1].x * len[1] - axis[2].x * len[2],
-               cen.y + axis[0].y * len[0] - axis[1].y * len[1] - axis[2].y * len[2],
-               cen.z + axis[0].z * len[0] - axis[1].z * len[1] - axis[2].z * len[2]);
-    glVertex3f(cen.x - axis[0].x * len[0] - axis[1].x * len[1] - axis[2].x * len[2],
-               cen.y - axis[0].y * len[0] - axis[1].y * len[1] - axis[2].y * len[2],
-               cen.z - axis[0].z * len[0] - axis[1].z * len[1] - axis[2].z * len[2]);
-    glVertex3f(cen.x - axis[0].x * len[0] - axis[1].x * len[1] + axis[2].x * len[2],
-               cen.y - axis[0].y * len[0] - axis[1].y * len[1] + axis[2].y * len[2],
-               cen.z - axis[0].z * len[0] - axis[1].z * len[1] + axis[2].z * len[2]);
-    glEnd();
-
-    if( drawMode & DRAW_BV_BLENDED)
-      glBegin(GL_QUADS);
-    else
-      glBegin(GL_LINE_LOOP);
-    glVertex3f(cen.x - axis[0].x * len[0] - axis[1].x * len[1] + axis[2].x * len[2],
-               cen.y - axis[0].y * len[0] - axis[1].y * len[1] + axis[2].y * len[2],
-               cen.z - axis[0].z * len[0] - axis[1].z * len[1] + axis[2].z * len[2]);
-    glVertex3f(cen.x - axis[0].x * len[0] - axis[1].x * len[1] - axis[2].x * len[2],
-               cen.y - axis[0].y * len[0] - axis[1].y * len[1] - axis[2].y * len[2],
-               cen.z - axis[0].z * len[0] - axis[1].z * len[1] - axis[2].z * len[2]);
-    glVertex3f(cen.x - axis[0].x * len[0] + axis[1].x * len[1] - axis[2].x * len[2],
-               cen.y - axis[0].y * len[0] + axis[1].y * len[1] - axis[2].y * len[2],
-               cen.z - axis[0].z * len[0] + axis[1].z * len[1] - axis[2].z * len[2]);
-    glVertex3f(cen.x - axis[0].x * len[0] + axis[1].x * len[1] + axis[2].x * len[2],
-               cen.y - axis[0].y * len[0] + axis[1].y * len[1] + axis[2].y * len[2],
-               cen.z - axis[0].z * len[0] + axis[1].z * len[1] + axis[2].z * len[2]);
-    glEnd();
-
-    if( drawMode & DRAW_BV_BLENDED)
-      glBegin(GL_QUADS);
-    else
-      glBegin(GL_LINE_LOOP);
-    glVertex3f(cen.x - axis[0].x * len[0] + axis[1].x * len[1] - axis[2].x * len[2],
-               cen.y - axis[0].y * len[0] + axis[1].y * len[1] - axis[2].y * len[2],
-               cen.z - axis[0].z * len[0] + axis[1].z * len[1] - axis[2].z * len[2]);
-    glVertex3f(cen.x - axis[0].x * len[0] + axis[1].x * len[1] + axis[2].x * len[2],
-               cen.y - axis[0].y * len[0] + axis[1].y * len[1] + axis[2].y * len[2],
-               cen.z - axis[0].z * len[0] + axis[1].z * len[1] + axis[2].z * len[2]);
-    glVertex3f(cen.x + axis[0].x * len[0] + axis[1].x * len[1] + axis[2].x * len[2],
-               cen.y + axis[0].y * len[0] + axis[1].y * len[1] + axis[2].y * len[2],
-               cen.z + axis[0].z * len[0] + axis[1].z * len[1] + axis[2].z * len[2]);
-    glVertex3f(cen.x + axis[0].x * len[0] + axis[1].x * len[1] - axis[2].x * len[2],
-               cen.y + axis[0].y * len[0] + axis[1].y * len[1] - axis[2].y * len[2],
-               cen.z + axis[0].z * len[0] + axis[1].z * len[1] - axis[2].z * len[2]);
-    glEnd();
-
-
-    if( drawMode & DRAW_BV_BLENDED)
-    {
-      glBegin(GL_QUADS);
-      glVertex3f(cen.x - axis[0].x * len[0] + axis[1].x * len[1] - axis[2].x * len[2],
-                 cen.y - axis[0].y * len[0] + axis[1].y * len[1] - axis[2].y * len[2],
-                 cen.z - axis[0].z * len[0] + axis[1].z * len[1] - axis[2].z * len[2]);
+
+    if( depth == 0 /*!(drawMode & DRAW_SINGLE && depth != 0)*/)
+    {
+
+
+      Vector cen = this->bvElement->center;
+      Vector* axis = this->bvElement->axis;
+      float* len = this->bvElement->halfLength;
+
+      if( this->bvElement->bCollided)
+      {
+        glColor4f(1.0, 1.0, 1.0, .5); // COLLISION COLOR
+      }
+      else if( drawMode & DRAW_BV_BLENDED)
+      {
+        glColor4f(color.x, color.y, color.z, .5);
+      }
+
+      // debug out
+      if( this->obbTree->getOwner() != NULL)
+      {
+        PRINTF(4)("debug poly draw: depth: %i, mode: %i, entity-name: %s, class: %s\n", depth, drawMode, this->obbTree->getOwner()->getName(), this->obbTree->getOwner()->getClassName());
+      }
+      else
+        PRINTF(4)("debug poly draw: depth: %i, mode: %i\n", depth, drawMode);
+
+
+      /* draw bounding box */
+      if( drawMode & DRAW_BV_BLENDED)
+        glBegin(GL_QUADS);
+      else
+        glBegin(GL_LINE_LOOP);
+      glVertex3f(cen.x + axis[0].x * len[0] + axis[1].x * len[1] + axis[2].x * len[2],
+                 cen.y + axis[0].y * len[0] + axis[1].y * len[1] + axis[2].y * len[2],
+                 cen.z + axis[0].z * len[0] + axis[1].z * len[1] + axis[2].z * len[2]);
       glVertex3f(cen.x + axis[0].x * len[0] + axis[1].x * len[1] - axis[2].x * len[2],
                  cen.y + axis[0].y * len[0] + axis[1].y * len[1] - axis[2].y * len[2],
@@ -1053,10 +797,52 @@
                  cen.y + axis[0].y * len[0] - axis[1].y * len[1] - axis[2].y * len[2],
                  cen.z + axis[0].z * len[0] - axis[1].z * len[1] - axis[2].z * len[2]);
+      glVertex3f(cen.x + axis[0].x * len[0] - axis[1].x * len[1] + axis[2].x * len[2],
+                 cen.y + axis[0].y * len[0] - axis[1].y * len[1] + axis[2].y * len[2],
+                 cen.z + axis[0].z * len[0] - axis[1].z * len[1] + axis[2].z * len[2]);
+      glEnd();
+
+      if( drawMode & DRAW_BV_BLENDED)
+        glBegin(GL_QUADS);
+      else
+        glBegin(GL_LINE_LOOP);
+      glVertex3f(cen.x + axis[0].x * len[0] - axis[1].x * len[1] + axis[2].x * len[2],
+                 cen.y + axis[0].y * len[0] - axis[1].y * len[1] + axis[2].y * len[2],
+                 cen.z + axis[0].z * len[0] - axis[1].z * len[1] + axis[2].z * len[2]);
+      glVertex3f(cen.x + axis[0].x * len[0] - axis[1].x * len[1] - axis[2].x * len[2],
+                 cen.y + axis[0].y * len[0] - axis[1].y * len[1] - axis[2].y * len[2],
+                 cen.z + axis[0].z * len[0] - axis[1].z * len[1] - axis[2].z * len[2]);
       glVertex3f(cen.x - axis[0].x * len[0] - axis[1].x * len[1] - axis[2].x * len[2],
                  cen.y - axis[0].y * len[0] - axis[1].y * len[1] - axis[2].y * len[2],
                  cen.z - axis[0].z * len[0] - axis[1].z * len[1] - axis[2].z * len[2]);
+      glVertex3f(cen.x - axis[0].x * len[0] - axis[1].x * len[1] + axis[2].x * len[2],
+                 cen.y - axis[0].y * len[0] - axis[1].y * len[1] + axis[2].y * len[2],
+                 cen.z - axis[0].z * len[0] - axis[1].z * len[1] + axis[2].z * len[2]);
       glEnd();
 
-      glBegin(GL_QUADS);
+      if( drawMode & DRAW_BV_BLENDED)
+        glBegin(GL_QUADS);
+      else
+        glBegin(GL_LINE_LOOP);
+      glVertex3f(cen.x - axis[0].x * len[0] - axis[1].x * len[1] + axis[2].x * len[2],
+                 cen.y - axis[0].y * len[0] - axis[1].y * len[1] + axis[2].y * len[2],
+                 cen.z - axis[0].z * len[0] - axis[1].z * len[1] + axis[2].z * len[2]);
+      glVertex3f(cen.x - axis[0].x * len[0] - axis[1].x * len[1] - axis[2].x * len[2],
+                 cen.y - axis[0].y * len[0] - axis[1].y * len[1] - axis[2].y * len[2],
+                 cen.z - axis[0].z * len[0] - axis[1].z * len[1] - axis[2].z * len[2]);
+      glVertex3f(cen.x - axis[0].x * len[0] + axis[1].x * len[1] - axis[2].x * len[2],
+                 cen.y - axis[0].y * len[0] + axis[1].y * len[1] - axis[2].y * len[2],
+                 cen.z - axis[0].z * len[0] + axis[1].z * len[1] - axis[2].z * len[2]);
+      glVertex3f(cen.x - axis[0].x * len[0] + axis[1].x * len[1] + axis[2].x * len[2],
+                 cen.y - axis[0].y * len[0] + axis[1].y * len[1] + axis[2].y * len[2],
+                 cen.z - axis[0].z * len[0] + axis[1].z * len[1] + axis[2].z * len[2]);
+      glEnd();
+
+      if( drawMode & DRAW_BV_BLENDED)
+        glBegin(GL_QUADS);
+      else
+        glBegin(GL_LINE_LOOP);
+      glVertex3f(cen.x - axis[0].x * len[0] + axis[1].x * len[1] - axis[2].x * len[2],
+                 cen.y - axis[0].y * len[0] + axis[1].y * len[1] - axis[2].y * len[2],
+                 cen.z - axis[0].z * len[0] + axis[1].z * len[1] - axis[2].z * len[2]);
       glVertex3f(cen.x - axis[0].x * len[0] + axis[1].x * len[1] + axis[2].x * len[2],
                  cen.y - axis[0].y * len[0] + axis[1].y * len[1] + axis[2].y * len[2],
